#include <stdio.h>
#include <iostream>
using namespace std;

#define MAXPILA 20

//
// Implementacin de pilas con arreglos
class pila {
private:
    int elem[MAXPILA];
    int tope;
public:
    pila(){ tope = -1;};
    void vaciar(){ tope = -1;};
    bool push(int x);
    bool pop (int& x);
    bool top(int& x);
    bool vacia(){ return (tope==-1);};
    bool llena(){ return (tope==MAXPILA-1);};
};


//
// Inserta el elemento enviado como parmetro en la pila, falso si la pila est llena
bool pila::push(int dato){
	if (llena())
		return false;
	elem[++tope]=dato;
	return true;
}

//
// Devuelve el elemento del tope de la pila, falso si la pila est vacia
bool pila::top(int& dato){
	if(vacia())
		return false;
	dato=elem[tope];
	return true;
}

//
// Saca el elemento del tope de la pila y lo devuelve el el parmetro dato
bool pila::pop(int& dato){
	if(vacia())
		return false;
	dato=elem[tope--];
	return true;
}


main(){

    pila P;
    int e;

    cout << "Implementacion de Pila" << endl;

    P.push(1);
    P.push(2);
    P.push(3);
    P.push(4);
    P.push(5);

    P.top(e);
    cout << endl << "El elemento del tope es " << e << endl;

    while(P.pop(e))
        cout << e << endl;
}


