#include <stdio.h>
#include <iostream>
using namespace std;

#define MAXPILA 20

template <class T>
class pila {
private:
    T elem[MAXPILA];
    int tope;
public:
    pila(){ tope = -1;};
    void vaciar(){ tope = -1;};
    bool push(T x);
    bool pop (T& x);
    bool top(T& x);
    bool vacia(){ return (tope==-1);};
    bool llena(){ return (tope==MAXPILA-1);};
};

//
// Inserta el elemento enviado como parmetro en la pila, falso si la pila est llena
template <class T>
bool pila<T>::push(T dato){
	if (llena())
		return false;
	elem[++tope]=dato;
	return true;
}

//
// Devuelve el elemento del tope de la pila, falso si la pila est vacia
template <class T>
bool pila<T>::top(T& dato){
	if(vacia())
		return false;
	dato=elem[tope];
	return true;
}

//
// Saca el elemento del tope de la pila y lo devuelve el el parmetro dato
template <class T>
bool pila<T>::pop(T& dato){
	if(vacia())
		return false;
	dato=elem[tope--];
	return true;
}


main(){

    pila<int> P;
    int e;

    cout << "Implementacion de Pila enteros" << endl;

    P.push(1);
    P.push(2);
    P.push(3);
    P.push(4);
    P.push(5);

    P.top(e);
    cout << endl << "El elemento del tope es " << e << endl;

    while(P.pop(e))
        cout << e << endl;


    pila<char> PC;
    char ec;

    cout << endl << "Implementacion de Pila de Caracteres" << endl;

    PC.push('a');
    PC.push('b');
    PC.push('c');
    PC.push('d');
    PC.push('e');

    PC.top(ec);
    cout << endl << "El elemento del tope es " << ec << endl;

    while(PC.pop(ec))
        cout << ec << endl;

}
